<id>
User Display name History
</id>

<version>
2.1
</version>

<mod info>
This mod allow to create a Display Name History if user change their Display Name.

Modfile Package:
- Display_Name_History_V2_0.mod
- Display_Name_History_V2_0_german.mod
 
Installation:
1) Modify YaBB files using BoardMod or manually.
2) Load modified files to your server in ASCII mode.
 
Admin/Admin.pl (ASCII)
Admin/ModList.pl (ASCII)
Languages/English/Profile.lng (ASCII)
Sources/Profile.pl (ASCII)
Sources/SubList.pl (ASCII)
</mod info>

<author>
Boris Tjuvanov (MF-B) and Jeffrey Man (Jet Li)
</author>

<homepage>
http://yabb.xost.ru/ and http://www.grafix-world.nl
</homepage>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$DisplayNameHistory = "Display_Name_History|Boris Tjuvanov (<a href=\"http://www.mf-b.ru\" target=\"_blank\">MF-B</a>) and Jeffrey Man (<a href=\"http://www.grafix-world.nl\" target=\"_blank\">Jet Li</a>)|This mod allow to create a Display Name History if user change their Display Name.|2.1|November 27th 2007|";
	push (@installed_mods, "$DisplayNameHistory");
</add before>

<edit file>
Languages/English/Profile.lng
</edit file>

<search for>
'902' => 'Username',
</search for>

<add after>
'udnh1' => 'Display Name History',
'udnh2' => 'Changed from',
'udnh3' => 'Into',
'udnh4' => 'Date of change(s)',
'udnh5' => 'Close Window',
'udnh6' => 'Last 10 changes',
</add after>

<edit file>
Sources/Profile.pl
</edit file>

<search for>
1;
</search for>

<add before>
sub UDNameHistoryWrite {
      
	my $usern = $_[0];
	my $useroldn = $_[1];
	my $usernewn = $_[2];
	my $datahist = time;
	my $unhistory = qq~$useroldn|$usernewn|$datahist~;

	if (!${$uid.$usern}{'unamehistory'})	{
		${$uid.$usern}{'unamehistory'} = "$unhistory";
	} else {
		my @currentHistoryList = split('\/\/', ${$uid.$usern}{'unamehistory'});
		push(@currentHistoryList, $unhistory);
		my $count = @currentHistoryList;
		if ($count > 10) { shift(@currentHistoryList) }
		$newHistoryList = join('//', @currentHistoryList);
		${$uid.$usern}{'unamehistory'} = "$newHistoryList";
	}
	&UserAccount($usern, "update");
}


sub UDNameHistory {
      
      my $usernhitory = $INFO{'user'} || '';
      if (!$usernhitory) { exit; }
      if ($do_scramble_id) { $usernhitory = &decloak($usernhitory); }
      if (!${$uid.$usernhitory}{'password'}) { &LoadUser($usernhitory); }
      my @udnhistory = split('\/\/', ${$uid.$usernhitory}{'unamehistory'});
      my $output .= "Content-type: text/html\n";
      if ($yySetCookies) { $output .= $yySetCookies; }
      $output .= "\n";

      $output .= qq~
      <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
      <html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
      <head>
      <title>$whptxt{'01'}</title>
      <link rel="stylesheet" href="$forumstylesurl/$usestyle.css" type="text/css" />
      </head>
      <body style="min-width: 450px;">
      <table border="0" cellpadding="4" cellspacing="1" width="100%" class="bordercolor">
      <tr>
            <td class="titlebg" align="center" colspan="3"><b>$profile_txt{'udnh1'}</b><br />$profile_txt{'udnh6'}</td>
      </tr>
      ~;

      $output .= qq~
      <tr>
            <td class="catbg">$profile_txt{'udnh2'}</td>
            <td class="catbg">$profile_txt{'udnh3'}</td>
            <td class="catbg">$profile_txt{'udnh4'}</td>
      </tr>
      ~;
      
      foreach my $member (@udnhistory) {
            my ($uoldn, $unewn, $udata) = split(/\|/, $member);
            $udata = &timeformat($udata);
            $output .= qq~
            <tr>
                  <td class="windowbg2">$uoldn</td>
                  <td class="windowbg2">$unewn</td>
                  <td class="windowbg2">$udata</td>
            </tr>
            ~;
      }

      $output .= qq~
      <tr>
      <td colspan="3" class="windowbg" align="center"><a href="javascript:window.close();">$profile_txt{'udnh5'}</a></td>
      </tr>
      </table>
      </body>
      </html>
      ~;
      
if ($gzcomp && $gzaccept) {
      if ($gzcomp == 1) {
            $| = 1;
            open(GZIP, "| gzip -f");
            print GZIP $output;
            close(GZIP);
      } else {
            require Compress::Zlib;
            binmode STDOUT;
            print Compress::Zlib::memGzip($output);
      }
} else {
      print $output;
}

exit;

}
</add before>

<search for>
		$yySetLocation = qq~$scripturl?action=$scriptAction;username=$useraccount{$member{'username'}};sid=$INFO{'sid'}~;
</search for>

<add before>
		if ($member{'name'} ne $member{'oldname'}) { &UDNameHistoryWrite($user,$member{'oldname'},$member{'name'}); }
</add before>

<search for>
	if (${$uid.$user}{'gender'}) {
</search for>

<add before>
	if (${$uid.$user}{'unamehistory'}) {
		$unamehistory = qq~
		<script language="JavaScript1.2" type="text/javascript">
		<!-- 
		function NHistory(udnh) {
		window.open('$scripturl?action=udnhistory;user='+udnh, '', 'menubar=no,toolbar=no,top=50,left=50,scrollbars=yes,resizable=no,width=450,height=300');
		}
		//-->
		</script>
		<a href="javascript:void(0);" onclick="NHistory('$useraccount{$user}');">$profile_txt{'udnh1'}</a><br />
		~;
	}
</add before>

<search for>
			<span style="font-size: 18px;">${$uid.$user}{'realname'}</span><br />
</search for>

<add after>
			$unamehistory
</add after>

<search for>
   <td align="left"><input type="text" maxlength="30" name="name" size="30" value="${$uid.$user}{'realname'}" /></td>
</search for>

<replace>
   <td align="left"><input type="text" maxlength="30" name="name" size="30" value="${$uid.$user}{'realname'}" /><input type="hidden" name="oldname" value="${$uid.$user}{'realname'}" /></td>
</replace>

<edit file>
Sources/SubList.pl
</edit file>

<search for>
'usersrecentposts',"Profile.pl&usersrecentposts",
</search for>

<add before>
'udnhistory',"Profile.pl&UDNameHistory",
</add before>

<edit file>
Sources/System.pl
</edit file>

<search for>
	fopen(UPDATEUSER, ">$memberdir/$user.$userext",1) || &fatal_error('cannot_open', "$memberdir/$user.$userext", 1);
</search for>

<add before>
	push (@tags,qw(unamehistory));
</add before>